; labeltemplates.scm: Templates for labels.scm.
; Copyright (C) 2005 by Akkana Peck, akkana@shallowsky.com.
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; LABEL TEMPLATES
;; Eventually these should move to a separate, auto-generated file.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Rectangular labels: (name comment (w h) (nx ny x0 y0 dx dy))
(define label-templates-rectangular
  '(

;; File: /usr/share/glabels/templates/misc-us-templates.xml
    ( "Tough-Tags TTLW-2016" "Microtube labels" ( 92.16 36 ) (5 17 68 4.17 100.8 45.3))
    ( "Netc 749303-70001 " "DLT Labels" ( 162 59.4 ) (3 10 36 45 189 72))
    ( "Neato Slimline CD Case, spine" "Slimline CD Case (upside down)" ( 394.5 342.5 ) (1 2 96.5 41.9 0 363))
    ( "Neato Slimline CD Case" "Slimline CD Case (rightside up)" ( 394.5 342.5 ) (1 2 130 41.9 0 363))
    ( "Stomper PRO Spine" "PRO CD Labels 2-up (CD spine only)" ( 288 20 ) (2 1 18 385 288 0))
    ( "Stomper PRO Zip" "PRO CD Labels 2-up (Face only)" ( 168 142 ) (1 2 407 68 0 142))
    ( "Neato USCD2lbl Rectangles" "CD Template Rectangles" ( 77.04 234.36 ) (2 1 51.3 279.72 433.44 0))
    ( "Southworth BC" "Business Cards" ( 252 144 ) (2 5 36 36 288 144))

;; File: /usr/share/glabels/templates/avery-us-templates.xml
    ( "Avery LSK-3.5" "" ( 3.13in 0.5in ) (1 20 0.5in 0.5in 4.38in 0.5in))
    ( "Avery LSK-3" "" ( 3.13in 0.5in ) (2 20 0.5in 0.5in 4.38in 0.5in))
    ( "Avery LSK-5.5" "" ( 1.75in 0.5in ) (2 20 0.5in 0.3in 2.05in 0.5in))
    ( "Avery LSK-5" "" ( 1.75in 0.5in ) (4 20 0.5in 0.3in 2.05in 0.5in))
    ( "Avery LSK-8.5" "" ( 1.13in 0.5in ) (2 20 0.5in 0.5in 2.13in 0.5in))
    ( "Avery LSK-8" "" ( 1.13in 0.5in ) (4 20 0.5in 0.5in 2.13in 0.5in))
    ( "Avery  3274.1" "Square Labels" ( 180 180 ) (3 3 22.5 90 193.5 216))
    ( "Avery  8165" "Full Sheet Labels" ( 612 792 ) (1 1 0 0 0 0))
    ( "Avery  5997-Spine" "Video Tape Spine Labels" ( 414 48 ) (1 15 99 36 0 48))
    ( "Avery  5997-Face" "Video Tape Face Labels" ( 220 133 ) (2 5 80 60.5 236 133))
    ( "Avery  5395" "Name Badge Labels" ( 235 168 ) (2 4 53 42 272.5 180.5))
    ( "Avery  8373" "Business Cards" ( 252 144 ) (2 4 36 54 288 180))
    ( "Avery  5371" "Business Cards" ( 252 144 ) (2 5 54 36 252 144))
    ( "Avery  5366" "Filing Labels" ( 252 48 ) (2 15 36 36 288 48))
    ( "Avery  6490" "Diskette Labels" ( 193.5 144 ) (3 5 9.215999926 36 200.2679959 144))
    ( "Avery  5196" "Diskette Labels" ( 198 198 ) (3 3 9 36 198 216))
    ( "Avery  5167" "Return Address Labels" ( 126 36 ) (4 20 20.25 36 148.5 36))
    ( "Avery  5164" "Shipping Labels" ( 288 234 ) (2 3 13 36 301 234))
    ( "Avery  5163" "Shipping Labels" ( 288 144 ) (2 5 11.25 36 301.5 144))
    ( "Avery  6879" "Address Labels" ( 270 90 ) (2 6 27 81 288 108))
    ( "Avery  5162" "Address Labels" ( 288 96 ) (2 7 10.5 60 303 96))
    ( "Avery  5161" "Address Labels" ( 288 72 ) (2 10 11.5 36 303 72))
    ( "Avery  5160" "Address Labels" ( 189 72 ) (3 10 11.5 36 200 72))
    ) )

;; CD Labels: (name comment (radius hole) (nx ny x0 y0 dx dy))
(define label-templates-cd
  '(
    ("Avery 5931" "CD Labels, 2 per sheet" (166.5 58.5) (1 2 139.5 49.5 0 360))
    ) )

;; Paper sizes we recognize:
;; Note, this is currently somewhat bogus because the label templates are
;; specific to a particular paper size.
(define page-sizes
  '(
    ("a4" 595.276 841.89)
    ("us-letter" 612 792)
    ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; END LABEL TEMPLATES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


